searchNodes=[{"doc":"Parameter helps you shape data from external sources into Elixir internal types. Use it to deal with any external data in general, such as API integrations, parsing user input, or validating data that comes into your system. Parameter offers the following helpers: Schema creation and validation Input data validation Deserialization Serialization Schema First step for dealing with external data is to create a schema that shape the data: defmodule UserParam do use Parameter.Schema alias Parameter.Validators param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; field :email , :string , validator : &amp; Validators . email / 1 has_one :address , AddressParam do field :city , :string , required : true field :street , :string field :number , :integer end end end Now it's possible to Load (deserialize) the schema against external data: params = %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;lastName&quot; =&gt; &quot;Doe&quot; , &quot;email&quot; =&gt; &quot;john@email.com&quot; , &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;street&quot; =&gt; &quot;York&quot; } } Parameter . load ( UserParam , params ) { :ok , %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , email : &quot;john@email.com&quot; , address : %{ city : &quot;New York&quot; , street : &quot;York&quot; } } } or Dump (serialize) a populated schema to the source: schema = %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , email : &quot;john@email.com&quot; , address : %{ city : &quot;New York&quot; , street : &quot;York&quot; } } Parameter . dump ( UserParam , params ) { :ok , %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;lastName&quot; =&gt; &quot;Doe&quot; , &quot;email&quot; =&gt; &quot;john@email.com&quot; , &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;street&quot; =&gt; &quot;York&quot; } } } For more schema options checkout Parameter.Schema","ref":"Parameter.html","title":"Parameter","type":"module"},{"doc":"Dump the loaded parameters. Options :exclude - Accepts a list of fields to be excluded when dumping the loaded parameter. This option is useful if you have fields in your schema are only for loading. :ignore_nil - When true will ignore nil values when dumping the parameters, when false (default) it will dump the nil values. :ignore_empty - When true will ignore empty &quot;&quot; values when dumping the parameters, when false (default) it will dump the empty values. :many - When true will parse the input data as list, when false (default) it parses as map Examples defmodule UserParam do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; has_one :address , Address do field :city , :string , required : true field :street , :string field :number , :integer end end end loaded_params = %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } } Parameter . dump ( UserParam , params ) { :ok , %{ &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;street&quot; =&gt; &quot;broadway&quot; } , &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;lastName&quot; =&gt; &quot;Doe&quot; } } # excluding fields Parameter . dump ( UserParam , params , exclude : [ :first_name , { :address , [ :city ] } ] ) { :ok , %{ &quot;address&quot; =&gt; %{ &quot;street&quot; =&gt; &quot;broadway&quot; } , &quot;lastName&quot; =&gt; &quot;Doe&quot; } }","ref":"Parameter.html#dump/3","title":"Parameter.dump/3","type":"function"},{"doc":"Loads parameters into the given schema. Options :struct - If set to true loads the schema into a structure. If false (default) loads with plain maps. :unknown - Defines the behaviour when unknown fields are presented on the parameters. The options are :ignore (default) or :error . :exclude - Accepts a list of fields to be excluded when loading the parameters. This option is useful if you have fields in your schema are only for dump. The field will not be checked for any validation if it's on the exclude list. :ignore_nil - When true will ignore nil values when loading the parameters, when false (default) it will load the nil values. :ignore_empty - When true will ignore empty &quot;&quot; values when loading the parameters, when false (default) it will load the empty values. :many - When true will parse the input data as list, when false (default) it parses as map Examples defmodule UserParam do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; has_one :address , Address do field :city , :string , required : true field :street , :string field :number , :integer end end end params = %{ &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;street&quot; =&gt; &quot;broadway&quot; } , &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;lastName&quot; =&gt; &quot;Doe&quot; } Parameter . load ( UserParam , params ) { :ok , %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } } } # Using struct options Parameter . load ( UserParam , params , struct : true ) { :ok , % UserParam { first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , address : % AddressParam { city : &quot;New York&quot; , street : &quot;broadway&quot; } } } # Using many: true for lists Parameter . load ( UserParam , [ params , params ] , many : true ) { :ok , [ %{ address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } , first_name : &quot;John&quot; , last_name : &quot;Doe&quot; } , %{ address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } , first_name : &quot;John&quot; , last_name : &quot;Doe&quot; } ] } # Excluding fields Parameter . load ( UserParam , params , exclude : [ :first_name , { :address , [ :city ] } ] ) { :ok , %{ last_name : &quot;Doe&quot; , address : %{ street : &quot;broadway&quot; } } } # Unknown fields should return errors params = %{ &quot;user_token&quot; =&gt; &quot;3hgj81312312&quot; } Parameter . load ( UserParam , params , unknown : :error ) { :error , %{ &quot;user_token&quot; =&gt; &quot;unknown field&quot; } } # Invalid data should return validation errors: params = %{ &quot;address&quot; =&gt; %{ &quot;city&quot; =&gt; &quot;New York&quot; , &quot;number&quot; =&gt; &quot;123AB&quot; } , &quot;lastName&quot; =&gt; &quot;Doe&quot; } Parameter . load ( UserParam , params ) { :error , %{ first_name : &quot;is required&quot; , address : %{ number : &quot;invalid integer type&quot; } , } } Parameter . load ( UserParam , [ params , params ] , many : true ) { :error , %{ 0 =&gt; %{ address : %{ number : &quot;invalid integer type&quot; } , first_name : &quot;is required&quot; } , 1 =&gt; %{ address : %{ number : &quot;invalid integer type&quot; } , first_name : &quot;is required&quot; } } } Loading map with atom keys It's also possible to load map with atom keys. Parameter schemas should not implement the key option for this to work. defmodule UserParam do use Parameter.Schema param do field :first_name , :string , required : true field :last_name , :string end end params = %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; } Parameter . load ( UserParam , params ) { :ok , %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; } } # String maps will also be correctly loaded if they have the same key params = %{ &quot;first_name&quot; =&gt; &quot;John&quot; , &quot;last_name&quot; =&gt; &quot;Doe&quot; } Parameter . load ( UserParam , params ) { :ok , %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; } } # But the same key should not be present in both String and Atom keys: params = %{ &quot;first_name&quot; =&gt; &quot;John&quot; , first_name : &quot;John&quot; } Parameter . load ( UserParam , params ) { :error , %{ first_name : &quot;field is present as atom and string keys&quot; } }","ref":"Parameter.html#load/3","title":"Parameter.load/3","type":"function"},{"doc":"Validate parameters. This function is meant to be used when the data is loaded or created internally. validate/3 will validate field types, required fields and Parameter.Validators functions. Options :exclude - Accepts a list of fields to be excluded when validating the parameters. :many - When true will parse the input data as list, when false (default) it parses as map Examples defmodule UserParam do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; has_one :address , Address do field :city , :string , required : true field :street , :string field :number , :integer end end end params = %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; } } Parameter . validate ( UserParam , params ) :ok # Invalid data params = %{ last_name : 12 , address : %{ city : &quot;New York&quot; , street : &quot;broadway&quot; , number : &quot;A&quot; } } Parameter . validate ( UserParam , params ) { :error , %{ address : %{ number : &quot;invalid integer type&quot; } , first_name : &quot;is required&quot; , last_name : &quot;invalid string type&quot; } }","ref":"Parameter.html#validate/3","title":"Parameter.validate/3","type":"function"},{"doc":"The field inside a Parameter Schema have the following structure: field :name , :type , opts :name - Atom key that defines the field name :type - Type from Parameter.Types . For custom types check the Parameter.Parametrizable behaviour. :opts - Keyword with field options. Options :key - This is the key from the params that will be converted to the field schema. Examples: If an input field use camelCase for mapping first_name , this option should be set as &quot;firstName&quot;. If an input field use the same case for the field definition, this key can be ignored. :default - Default value of the field when no value is given. :load_default - Default value of the field when no value is given when loading with Parameter.load/3 function. This option should not be used at the same time as default option. :dump_default - Default value of the field when no value is given when loading with Parameter.dump/3 function. This option should not be used at the same time as default option. :required - Defines if the field needs to be present when parsing the input. Parameter.load/3 will return an error if the value is missing from the input data. :validator - Validation function that will validate the field after loading. :virtual - If true the field will be ignored on Parameter.load/3 and Parameter.dump/3 functions. :on_load - Function to specify how to load the field. The function must have two arguments where the first one is the field value and the second one will be the data to be loaded. Should return {:ok, value} or {:error, reason} tuple. :on_dump - Function to specify how to dump the field. The function must have two arguments where the first one is the field value and the second one will be the data to be dumped. Should return {:ok, value} or {:error, reason} tuple. NOTE: Validation only occurs on Parameter.load/3 . By desgin, data passed into Parameter.dump/3 are considered valid. Example As an example having an email field that is required and needs email validation could be implemented this way: field :email , :string , required : true , validator : &amp; Parameter.Validators . email / 1","ref":"Parameter.Field.html","title":"Parameter.Field","type":"module"},{"doc":"","ref":"Parameter.Field.html#t:t/0","title":"Parameter.Field.t/0","type":"type"},{"doc":"The first step for building a schema for your data is to create a schema definition to model the external data. This can be achieved by using the Parameter.Schema macro. Schema The example below mimics an User model that have one main_address and a list of phones . defmodule User do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; , required : true , default : &quot;&quot; has_one :main_address , Address , key : &quot;mainAddress&quot; , required : true has_many :phones , Phone end end defmodule Address do use Parameter.Schema param do field :city , :string , required : true field :street , :string field :number , :integer end end defmodule Phone do use Parameter.Schema param do field :country , :string field :number , :integer end end Parameter offers other ways for creating a schema such as nesting the has_one and has_many fields. This require module name as the second parameter using do at the end: defmodule User do use Parameter.Schema param do field :first_name , :string , key : &quot;firstName&quot; , required : true field :last_name , :string , key : &quot;lastName&quot; , required : true , default : &quot;&quot; has_one :main_address , Address , key : &quot;mainAddress&quot; , required : true do field :city , :string , required : true field :street , :string field :number , :integer end has_many :phones , Phone do field :country , :string field :number , :integer end end end Another possibility is avoiding creating files for a schema at all. This can be done by importing Parameter.Schema and using the param/2 macro. This is useful for adding params in Phoenix controllers. For example: defmodule MyProjectWeb.UserController do use MyProjectWeb , :controller import Parameter.Schema alias MyProject.Users param UserParams do field :first_name , :string , required : true field :last_name , :string , required : true end def create ( conn , params ) do with { :ok , user_params } &lt;- Parameter . load ( __MODULE__ . UserParams , params ) , { :ok , user } &lt;- Users . create_user ( user_params ) do render ( conn , &quot;user.json&quot; , %{ user : user } ) end end end It's recommended to use this approach when the schema will only be used in a single module. Runtime Schemas It's also possible to create schemas via runtime without relying on any macros. The API is almost the same comparing to the macro's examples: schema = %{ first_name : [ key : &quot;firstName&quot; , type : :string , required : true ] , address : [ type : { :map , %{ street : [ type : :string , required : true ] } } ] , phones : [ type : { :array , %{ country : [ type : :string , required : true ] } } ] } |&gt; Parameter.Schema . compile! ( ) Parameter . load ( schema , %{ &quot;firstName&quot; =&gt; &quot;John&quot; } ) { :ok , %{ first_name : &quot;John&quot; } } The same API can also be evaluated on compile time by using module attributes: defmodule UserParams do alias Parameter.Schema @schema %{ first_name : [ key : &quot;firstName&quot; , type : :string , required : true ] , address : [ required : true , type : { :map , %{ street : [ type : :string , required : true ] } } ] , phones : [ type : { :array , %{ country : [ type : :string , required : true ] } } ] } |&gt; Schema . compile! ( ) def load ( params ) do Parameter . load ( @schema , params ) end end This makes it easy to dynamically create schemas or just avoid using any macros. Required fields By default, Parameter.Schema considers all fields to be optional when validating the schema. This behaviour can be changed by passing the module attribute @fields_required true on the module where the schema is declared. Example defmodule MyApp.UserSchema do use Parameter.Schema @fields_required true param do field :name , :string field :age , :integer end end Parameter . load ( MyApp.UserSchema , %{ } ) { :error , %{ age : &quot;is required&quot; , name : &quot;is required&quot; } } Custom field loading and dumping The load and dump behavior can be customized per field by implementing on_load or on_dump functions in the field definition. This can be useful if the field needs to be fetched or even validate in a different way than the defaults implemented by Parameter . Both functions should return {:ok, value} or {:error, reason} tuple. For example, imagine that there is a parameter called full_name in your schema that you want to customize on how it will be parsed: defmodule MyApp.UserSchema do use Parameter.Schema param do field :first_name , :string field :last_name , :string field :full_name , :string , on_load : &amp; __MODULE__ . load_full_name / 2 end def load_full_name ( value , params ) do # if `full_name` is not `nil` it just return the `full_name` if value do { :ok , value } else # Otherwise it will join the `first_name` and `last_name` params { :ok , params [ &quot;first_name&quot; ] &lt;&gt; &quot; &quot; &lt;&gt; params [ &quot;last_name&quot; ] } end end end Now when loading, the full_name field will be handled by the load_full_name/2 function: Parameter . load ( MyApp.UserSchema , %{ first_name : &quot;John&quot; , last_name : &quot;Doe&quot; , full_name : nil } ) { :ok , %{ first_name : &quot;John&quot; , full_name : &quot;John Doe&quot; , last_name : &quot;Doe&quot; } } The same behavior is possible when dumping the schema parameters by using on_dump/2 function: schema = %{ level : [ type : :integer , on_dump : fn value , _input -&gt; { :ok , value || 0 } end ] } |&gt; Parameter.Schema . compile! ( ) Parameter . dump ( schema , %{ level : nil } ) { :ok , %{ &quot;level&quot; =&gt; 0 } }","ref":"Parameter.Schema.html","title":"Parameter.Schema","type":"module"},{"doc":"See Parameter.Schema.Compiler.compile_schema!/1 .","ref":"Parameter.Schema.html#compile!/1","title":"Parameter.Schema.compile!/1","type":"function"},{"doc":"","ref":"Parameter.Schema.html#field_key/2","title":"Parameter.Schema.field_key/2","type":"function"},{"doc":"","ref":"Parameter.Schema.html#field_keys/1","title":"Parameter.Schema.field_keys/1","type":"function"},{"doc":"","ref":"Parameter.Schema.html#fields/1","title":"Parameter.Schema.fields/1","type":"function"},{"doc":"Parameter supports different types to be used in the field inside a schema. The available types are: string atom any integer float boolean map {map, nested_type} array {array, nested_type} date time datetime naive_datetime decimal * enum ** * For decimal type add the decimal library into your project. ** Check the Parameter.Enum for more information on how to use enums. For implementing custom types check the Parameter.Parametrizable module. Implementing this behavour in a module makes eligible to be a field in the schema definition.","ref":"Parameter.Types.html","title":"Parameter.Types","type":"module"},{"doc":"","ref":"Parameter.Types.html#base_type?/1","title":"Parameter.Types.base_type?/1","type":"function"},{"doc":"","ref":"Parameter.Types.html#composite_inner_type?/1","title":"Parameter.Types.composite_inner_type?/1","type":"function"},{"doc":"","ref":"Parameter.Types.html#composite_type?/1","title":"Parameter.Types.composite_type?/1","type":"function"},{"doc":"","ref":"Parameter.Types.html#dump/2","title":"Parameter.Types.dump/2","type":"function"},{"doc":"","ref":"Parameter.Types.html#load/2","title":"Parameter.Types.load/2","type":"function"},{"doc":"","ref":"Parameter.Types.html#validate/2","title":"Parameter.Types.validate/2","type":"function"},{"doc":"","ref":"Parameter.Types.html#validate!/2","title":"Parameter.Types.validate!/2","type":"function"},{"doc":"","ref":"Parameter.Types.html#t:base_types/0","title":"Parameter.Types.base_types/0","type":"type"},{"doc":"","ref":"Parameter.Types.html#t:composite_types/0","title":"Parameter.Types.composite_types/0","type":"type"},{"doc":"","ref":"Parameter.Types.html#t:t/0","title":"Parameter.Types.t/0","type":"type"},{"doc":"Common validators to use within fields of the Parameter.Schema Examples param User do field :email , :string , validator : &amp; Validators . email ( &amp;1 ) end iex&gt; Parameter . load ( User , %{ &quot;email&quot; =&gt; &quot;not an email&quot; } ) { :error , %{ email : &quot;is invalid&quot; } }","ref":"Parameter.Validators.html","title":"Parameter.Validators","type":"module"},{"doc":"Validates email address param User do field :email , :string , validator : &amp; Validators . email ( &amp;1 ) end iex&gt; Parameter . load ( User , %{ &quot;email&quot; =&gt; &quot;not an email&quot; } ) { :error , %{ email : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;email&quot; =&gt; &quot;john@gmail.com&quot; } ) { :ok , %{ email : &quot;john@gmail.com&quot; } }","ref":"Parameter.Validators.html#email/1","title":"Parameter.Validators.email/1","type":"function"},{"doc":"Validates if value is equal to another param User do field :permission , :string , validator : { &amp; Validators . equal / 2 , to : &quot;admin&quot; } end iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;super_admin&quot; } ) { :error , %{ permission : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;admin&quot; } ) { :ok , %{ permission : &quot;admin&quot; } }","ref":"Parameter.Validators.html#equal/2","title":"Parameter.Validators.equal/2","type":"function"},{"doc":"Validates if a value is between a min and max param User do field :age , :integer , validator : { &amp; Validators . length / 2 , min : 18 , max : 50 } end iex&gt; Parameter . load ( User , %{ &quot;age&quot; =&gt; 12 } ) { :error , %{ age : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;age&quot; =&gt; 30 } ) { :ok , %{ age : 30 } }","ref":"Parameter.Validators.html#length/2","title":"Parameter.Validators.length/2","type":"function"},{"doc":"Validates if a value is not a member param User do field :permission , :atom , validator : { &amp; Validators . none_of / 2 , options : [ :admin , :super_admin ] } end iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;super_admin&quot; } ) { :error , %{ permission : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;normal_user&quot; } ) { :ok , %{ permission : :normal_user } }","ref":"Parameter.Validators.html#none_of/2","title":"Parameter.Validators.none_of/2","type":"function"},{"doc":"Validates if a value is a member of the list param User do field :permission , :atom , validator : { &amp; Validators . one_of / 2 , options : [ :admin , :super_admin ] } end iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;normal_user&quot; } ) { :error , %{ permission : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;permission&quot; =&gt; &quot;super_admin&quot; } ) { :ok , %{ permission : :super_admin } }","ref":"Parameter.Validators.html#one_of/2","title":"Parameter.Validators.one_of/2","type":"function"},{"doc":"Validates if a value matches a regex expression param User do field :code , :string , validator : { &amp; Validators . regex / 2 , regex : ~r/code/ } end iex&gt; Parameter . load ( User , %{ &quot;code&quot; =&gt; &quot;12345&quot; } ) { :error , %{ code : &quot;is invalid&quot; } } iex&gt; Parameter . load ( User , %{ &quot;code&quot; =&gt; &quot;code:12345&quot; } ) { :ok , %{ code : &quot;code:12345&quot; } }","ref":"Parameter.Validators.html#regex/2","title":"Parameter.Validators.regex/2","type":"function"},{"doc":"","ref":"Parameter.Validators.html#t:resp/0","title":"Parameter.Validators.resp/0","type":"type"},{"doc":"Enum type represents a group of constants that have a value with an associated key. Examples defmodule MyApp.UserParam do use Parameter.Schema enum Status do value :user_online , key : &quot;userOnline&quot; value :user_offline , key : &quot;userOffline&quot; end param do field :first_name , :string , key : &quot;firstName&quot; field :status , MyApp.UserParam.Status end end The Status enum should automatically translate the userOnline and userOffline values when loading to the respective atom values. Parameter . load ( MyApp.UserParam , %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;status&quot; =&gt; &quot;userOnline&quot; } ) { :ok , %{ first_name : &quot;John&quot; , status : :user_online } } Parameter . dump ( MyApp.UserParam , %{ first_name : &quot;John&quot; , status : :user_online } ) { :ok , %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;status&quot; =&gt; &quot;userOnline&quot; } } Enum also supports a shorter version if the key and value are already the same: defmodule MyApp.UserParam do ... enum Status , values : [ :user_online , :user_offline ] ... end Parameter . load ( MyApp.UserParam , %{ &quot;firstName&quot; =&gt; &quot;John&quot; , &quot;status&quot; =&gt; &quot;user_online&quot; } ) { :ok , %{ first_name : &quot;John&quot; , status : :user_online } } Using numbers is also allowed in enums: enum Status do value :active , key : 1 value :pending_request , key : 2 end Parameter . load ( MyApp.UserParam , %{ &quot;status&quot; =&gt; 1 } ) { :ok , %{ status : :active } } It's also possible to create enums in different modules by using the enum/1 macro: defmodule MyApp.Status do import Parameter.Enum enum do value :user_online , key : &quot;userOnline&quot; value :user_offline , key : &quot;userOffline&quot; end end defmodule MyApp.UserParam do use Parameter.Schema alias MyApp.Status param do field :first_name , :string , key : &quot;firstName&quot; field :status , Status end end And the short version: enum values : [ :user_online , :user_offline ]","ref":"Parameter.Enum.html","title":"Parameter.Enum","type":"module"},{"doc":"Custom types for fields can be done by implementing the Parameter.Parametrizable behaviour. This is useful when the basic types provided by Parameter.Types are not enough for loading, validating and dumping data. Examples To create a parameterized type, create a module as shown below: defmodule MyApp.CustomType do use Parameter.Parametrizable @impl true def load ( value ) do { :ok , value } end @impl true def validate ( _value ) do :ok end @impl true def dump ( value ) do { :ok , value } end end Then use the new custom type on a param schema: param MyApp.CustomParam do field :custom_field , MyApp.CustomType , key : &quot;customField&quot; end In general is not necessary to implement dump function since using the macro use Parameter.Parametrizable will already use the validate function to dump the value as a default implementation.","ref":"Parameter.Parametrizable.html","title":"Parameter.Parametrizable","type":"behaviour"},{"doc":"","ref":"Parameter.Parametrizable.html#c:dump/1","title":"Parameter.Parametrizable.dump/1","type":"callback"},{"doc":"","ref":"Parameter.Parametrizable.html#c:load/1","title":"Parameter.Parametrizable.load/1","type":"callback"},{"doc":"","ref":"Parameter.Parametrizable.html#c:validate/1","title":"Parameter.Parametrizable.validate/1","type":"callback"},{"doc":"Any parameter type. It will accept any input value without validations. The same value loaded will be the same dumped.","ref":"Parameter.Types.AnyType.html","title":"Parameter.Types.AnyType","type":"module"},{"doc":"AnyType type will just return the same type value that is passed to dump function Examples iex&gt; Parameter.Types.AnyType . load ( :any_atom ) { :ok , :any_atom } iex&gt; Parameter.Types.AnyType . load ( &quot;some string&quot; ) { :ok , &quot;some string&quot; } iex&gt; Parameter.Types.AnyType . load ( nil ) { :ok , nil }","ref":"Parameter.Types.AnyType.html#dump/1","title":"Parameter.Types.AnyType.dump/1","type":"function"},{"doc":"Any type will just return the same type value that is passed to load function Examples iex&gt; Parameter.Types.AnyType . load ( :any_atom ) { :ok , :any_atom } iex&gt; Parameter.Types.AnyType . load ( &quot;some string&quot; ) { :ok , &quot;some string&quot; } iex&gt; Parameter.Types.AnyType . load ( nil ) { :ok , nil }","ref":"Parameter.Types.AnyType.html#load/1","title":"Parameter.Types.AnyType.load/1","type":"function"},{"doc":"Always return :ok , any value is valid","ref":"Parameter.Types.AnyType.html#validate/1","title":"Parameter.Types.AnyType.validate/1","type":"function"},{"doc":"Array parameter type","ref":"Parameter.Types.Array.html","title":"Parameter.Types.Array","type":"module"},{"doc":"Atom parameter type","ref":"Parameter.Types.Atom.html","title":"Parameter.Types.Atom","type":"module"},{"doc":"loads atom type Examples iex&gt; Parameter.Types.Atom . load ( :atom ) { :ok , :atom } iex&gt; Parameter.Types.Atom . load ( &quot;atom&quot; ) { :ok , :atom } iex&gt; Parameter.Types.Atom . load ( nil ) { :error , &quot;invalid atom type&quot; } iex&gt; Parameter.Types.Atom . load ( 123 ) { :error , &quot;invalid atom type&quot; }","ref":"Parameter.Types.Atom.html#load/1","title":"Parameter.Types.Atom.load/1","type":"function"},{"doc":"validate atom type Examples iex&gt; Parameter.Types.Atom . validate ( :atom ) :ok iex&gt; Parameter.Types.Atom . validate ( &quot;atom&quot; ) { :error , &quot;invalid atom type&quot; } iex&gt; Parameter.Types.Atom . validate ( nil ) { :error , &quot;invalid atom type&quot; } iex&gt; Parameter.Types.Atom . validate ( 123 ) { :error , &quot;invalid atom type&quot; }","ref":"Parameter.Types.Atom.html#validate/1","title":"Parameter.Types.Atom.validate/1","type":"function"},{"doc":"Boolean parameter type","ref":"Parameter.Types.Boolean.html","title":"Parameter.Types.Boolean","type":"module"},{"doc":"loads boolean type Examples iex&gt; Parameter.Types.Boolean . load ( true ) { :ok , true } iex&gt; Parameter.Types.Boolean . load ( &quot;true&quot; ) { :ok , true } iex&gt; Parameter.Types.Boolean . load ( &quot;True&quot; ) { :ok , true } iex&gt; Parameter.Types.Boolean . load ( &quot;false&quot; ) { :ok , false } iex&gt; Parameter.Types.Boolean . load ( 1 ) { :ok , true } iex&gt; Parameter.Types.Boolean . load ( 0 ) { :ok , false } iex&gt; Parameter.Types.Boolean . load ( &quot;not boolean&quot; ) { :error , &quot;invalid boolean type&quot; } iex&gt; Parameter.Types.Boolean . load ( :not_boolean ) { :error , &quot;invalid boolean type&quot; }","ref":"Parameter.Types.Boolean.html#load/1","title":"Parameter.Types.Boolean.load/1","type":"function"},{"doc":"validate boolean type Examples iex&gt; Parameter.Types.Boolean . validate ( true ) :ok iex&gt; Parameter.Types.Boolean . validate ( false ) :ok iex&gt; Parameter.Types.Boolean . validate ( &quot;true&quot; ) { :error , &quot;invalid boolean type&quot; } iex&gt; Parameter.Types.Boolean . validate ( nil ) { :error , &quot;invalid boolean type&quot; } iex&gt; Parameter.Types.Boolean . validate ( 123 ) { :error , &quot;invalid boolean type&quot; }","ref":"Parameter.Types.Boolean.html#validate/1","title":"Parameter.Types.Boolean.validate/1","type":"function"},{"doc":"Date parameter type","ref":"Parameter.Types.Date.html","title":"Parameter.Types.Date","type":"module"},{"doc":"loads Date type Examples iex&gt; Parameter.Types.Date . load ( % Date { year : 1990 , month : 5 , day : 1 } ) { :ok , ~D[1990-05-01] } iex&gt; Parameter.Types.Date . load ( { 2020 , 10 , 5 } ) { :ok , ~D[2020-10-05] } iex&gt; Parameter.Types.Date . load ( &quot;2015-01-23&quot; ) { :ok , ~D[2015-01-23] } iex&gt; Parameter.Types.Date . load ( &quot;2015-25-23&quot; ) { :error , &quot;invalid date type&quot; } iex&gt; Parameter.Types.Date . load ( :not_valid_type ) { :error , &quot;invalid date type&quot; }","ref":"Parameter.Types.Date.html#load/1","title":"Parameter.Types.Date.load/1","type":"function"},{"doc":"validate date type Examples iex&gt; Parameter.Types.Date . validate ( % Date { year : 1990 , month : 5 , day : 1 } ) :ok iex&gt; Parameter.Types.Date . validate ( ~D[1990-05-01] ) :ok iex&gt; Parameter.Types.Date . validate ( &quot;2015-01-23&quot; ) { :error , &quot;invalid date type&quot; }","ref":"Parameter.Types.Date.html#validate/1","title":"Parameter.Types.Date.validate/1","type":"function"},{"doc":"DateTime parameter type","ref":"Parameter.Types.DateTime.html","title":"Parameter.Types.DateTime","type":"module"},{"doc":"loads DateTime type Examples iex&gt; Parameter.Types.DateTime . load ( ~U[2018-11-15 10:00:00Z] ) { :ok , ~U[2018-11-15 10:00:00Z] } iex&gt; Parameter.Types.DateTime . load ( &quot;2015-01-23T23:50:07Z&quot; ) { :ok , ~U[2015-01-23 23:50:07Z] } iex&gt; Parameter.Types.DateTime . load ( &quot;2015-25-23&quot; ) { :error , &quot;invalid datetime type&quot; }","ref":"Parameter.Types.DateTime.html#load/1","title":"Parameter.Types.DateTime.load/1","type":"function"},{"doc":"validate date type Examples iex&gt; Parameter.Types.DateTime . validate ( ~U[2018-11-15 10:00:00Z] ) :ok iex&gt; Parameter.Types.DateTime . validate ( ~D[1990-05-01] ) { :error , &quot;invalid datetime type&quot; } iex&gt; Parameter.Types.DateTime . validate ( &quot;2015-01-23T23:50:07Z&quot; ) { :error , &quot;invalid datetime type&quot; }","ref":"Parameter.Types.DateTime.html#validate/1","title":"Parameter.Types.DateTime.validate/1","type":"function"},{"doc":"Decimal parameter type. Include the Decimal library on your application to use this type: def deps do [ { :parameter , &quot;~&gt; ...&quot; } , { :decimal , &quot;~&gt; 2.0&quot; } ] end","ref":"Parameter.Types.Decimal.html","title":"Parameter.Types.Decimal","type":"module"},{"doc":"Float parameter type","ref":"Parameter.Types.Float.html","title":"Parameter.Types.Float","type":"module"},{"doc":"loads float type Examples iex&gt; Parameter.Types.Float . load ( 1.5 ) { :ok , 1.5 } iex&gt; Parameter.Types.Float . load ( &quot;2.5&quot; ) { :ok , 2.5 } iex&gt; Parameter.Types.Float . load ( 1 ) { :ok , 1.0 } iex&gt; Parameter.Types.Float . load ( &quot;not float&quot; ) { :error , &quot;invalid float type&quot; } iex&gt; Parameter.Types.Float . load ( :atom ) { :error , &quot;invalid float type&quot; }","ref":"Parameter.Types.Float.html#load/1","title":"Parameter.Types.Float.load/1","type":"function"},{"doc":"Integer parameter type","ref":"Parameter.Types.Integer.html","title":"Parameter.Types.Integer","type":"module"},{"doc":"Map parameter type","ref":"Parameter.Types.Map.html","title":"Parameter.Types.Map","type":"module"},{"doc":"NaiveDateTime parameter type","ref":"Parameter.Types.NaiveDateTime.html","title":"Parameter.Types.NaiveDateTime","type":"module"},{"doc":"loads NaiveDateTime type Examples iex&gt; Parameter.Types.NaiveDateTime . load ( ~N[2000-01-01 23:00:07] ) { :ok , ~N[2000-01-01 23:00:07] } iex&gt; Parameter.Types.NaiveDateTime . load ( &quot;2000-01-01 22:00:07&quot; ) { :ok , ~N[2000-01-01 22:00:07] } iex&gt; Parameter.Types.NaiveDateTime . load ( { { 2021 , 05 , 11 } , { 22 , 30 , 10 } } ) { :ok , ~N[2021-05-11 22:30:10] } iex&gt; Parameter.Types.NaiveDateTime . load ( { { 2021 , 25 , 11 } , { 22 , 30 , 10 } } ) { :error , &quot;invalid naive_datetime type&quot; } iex&gt; Parameter.Types.NaiveDateTime . load ( &quot;2015-25-23&quot; ) { :error , &quot;invalid naive_datetime type&quot; }","ref":"Parameter.Types.NaiveDateTime.html#load/1","title":"Parameter.Types.NaiveDateTime.load/1","type":"function"},{"doc":"String parameter type","ref":"Parameter.Types.String.html","title":"Parameter.Types.String","type":"module"},{"doc":"Time parameter type","ref":"Parameter.Types.Time.html","title":"Parameter.Types.Time","type":"module"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements [Parameter.Schema.Compiler] Unify schema compiler for macro and functional API. [Parameter.Types.Any] Renamed module to Parameter.Types.AnyType to fix elixir warnings [Parameter] Fix load , dump and validate functions to correctly parse Enum values in nested schema. [Parameter.Schema] default options for nested schema is now available. Deprecations [Parameter.Types.List] removed type in favor of Array type","ref":"changelog.html#v0-12-x-2023-03-06","title":"Changelog - v0.12.x (2023-03-06)","type":"extras"},{"doc":"Enhancements [Parameter] Extra option ignore_empty for load/2 and dump/2 functions. [Parameter.Schema] has_one and has_many nested types as map and array composite types. Deprecations [Parameter.Enum] removed enum value macro with the as key.","ref":"changelog.html#v0-11-x-2023-01-18","title":"Changelog - v0.11.x (2023-01-18)","type":"extras"},{"doc":"Enhancements [Parameter] Extra option ignore_nil for load/2 and dump/2 functions. [Parameter.Types] New array type. [Parameter.Schema] Support for nested type on map and array . Improved code test coverage to 100%.","ref":"changelog.html#v0-10-x-2023-01-07","title":"Changelog - v0.10.x (2023-01-07)","type":"extras"},{"doc":"Enhancements [Parameter.Field] Support for on_load/2 and on_dump/2 functions in field definition.","ref":"changelog.html#v0-9-x-2023-01-04","title":"Changelog - v0.9.x (2023-01-04)","type":"extras"},{"doc":"Enhancements [Parameter.Schema] Supports compile/1 function for compiling runtime schemas. [Parameter] load/3 , validate/3 and dump/3 now support evaluating parameters using runtime schemas. [Parameter.Validators] Improved length/2 validator to support min and/or max attributes. Before it was only accepting both. Bug fixes [Parameter] Fix a bug where load/3 and validate/3 was evaluating the validator option wrongly. [Parameter.Field] Validator typespec. [Parameter.Enum] Fix evaluation of enum values inside Enum macro","ref":"changelog.html#v0-8-x-2022-12-10","title":"Changelog - v0.8.x (2022-12-10)","type":"extras"},{"doc":"Enhancements [Parameter] New validate/3 function [Parameter] Supports for load/3 parsing maps with atom keys [Parameter.Schema] Supports for fields_required module attribute on schema Bug fixes [Parameter] dump/3 function to load the value to be dumped [Parameter] consider basic types when loading, dumping or validating a schema [Parameter.Field] remove compile time verification for custom types","ref":"changelog.html#v0-7-x-2022-11-07","title":"Changelog - v0.7.x (2022-11-07)","type":"extras"},{"doc":"Enhancements [Parameter] API changes to support new parameter_ecto library [Parameter] Support for many flag on load/3 and dump/3 options [Parameter] Errors when parsing list return as map with %{index =&gt; reason} now instead of {:\#{index}, reason} to avoid atom creation [Parameter.Field] Support for load_default and dump_default options [Parameter.Enum] Deprecated as in favour of key Bug fixes [Parameter.Field] Return default value when calling Parameter.dump/3 with empty value.","ref":"changelog.html#v0-6-x-2022-11-06","title":"Changelog - v0.6.x (2022-11-06)","type":"extras"},{"doc":"Enhancements [Parameter] Support for exclude option for load/3 and dump/3 . [Parameter.Types] Support for any type [Parameter.Schema] Support for virtual fields","ref":"changelog.html#v0-5-x-2022-10-26","title":"Changelog - v0.5.x (2022-10-26)","type":"extras"}]